# -*- coding: utf-8 -*-
# License, author and contributors information in:
# __openerp__.py file at the root folder of this module.

from openerp import api, models, fields
from openerp.exceptions import ValidationError, except_orm, Warning, RedirectWarning
import logging

_log = logging.getLogger(__name__)


class ConfigOrder(models.Model):
    _name = 'repair.configorderimproved'
    _description = 'Config order improved'
    # _inherit = ['mail.thread', 'ir.needaction_mixin']

    def _get_user(self):
        return self.env.uid

    def _get_number(self):
        return self.env['ir.sequence'].get('repair.configorderimproved') or '*'

    name = fields.Char(
        string=u'Orden',
        readonly=True,
        default=_get_number
    )
    user_id = fields.Many2one(
        comodel_name='res.users',
        string='Técnico Responsable',
        default=_get_user
    )
    partner_id = fields.Many2one(
        comodel_name='res.partner',
        string='Cliente'
    )

    order_date = fields.Datetime(
        string='Fecha Instalación',
        default=fields.Datetime.now
    )
    planned_date = fields.Datetime(
        string='Fecha de Inicio'
    )
    pedido_obra = fields.Char(
        string='Pedido por'
    )
    name_obra = fields.Char(
        string='Obra'
    )
    movil = fields.Char(
        string='Móvil'
    )
    brand_eq = fields.Char(
        string='Marca Equipo'
    )
    gas_eq = fields.Char(
        string='Gas'
    )
    turb_eq = fields.Char(
        string='Turbina ev.'
    )
    model_eq = fields.Char(
        string='Modelo'
    )
    carga_eq = fields.Char(
        string='Carga (A)'
    )
    capacitor_eq = fields.Char(
        string='Capacitor'
    )
    serie_eq = fields.Char(
        string='N° Serie'
    )
    tension_eq = fields.Char(
        string='Tensión (V)'
    )
    largo_eq = fields.Char(
        string='Largo Ducto'
    )
    capacidad_eq = fields.Char(
        string='Capacidad'
    )
    presion_ini_eq = fields.Char(
        string='Presión Inicial'
    )
    presion_fin_eq = fields.Char(
        string='Presión Final'
    )
    estado_eq = fields.Char(
        string='Estado de equipo '
    )
    trabajo_eq = fields.Char(
        string='Trabajo realizado'
    )
    mante_eq = fields.Char(
        string='Mantenimiento'
    )
    garan_eq = fields.Char(
        string='Garantía'
    )
    ficha_eq= fields.Char(
        string='Ficha N°'
    )
    lacre_eq = fields.Char(
        string='Lacre/Sello'
    )
    tablero = fields.Char(
        string='Tablero'
    )
    disyuntor_tab = fields.Char(
        string='Disyuntor dif.2'
    )
    tension_tab = fields.Char(
        string='Tensión R (v)'
    )

    serie_tab = fields.Char(
        string='N° de Serie'
    )
    cargar_tab = fields.Char(
        string='Carga R (A)'
    )
    tensions_tab = fields.Char(
        string='Tensión S (v)'
    )
    limitador_tab = fields.Char(
        string='Limitador (A)'
    )
    cargas_tab = fields.Char(
        string='Carga S (A)'
    )
    tensiont_tab = fields.Char(
        string='Tensión T (v)'
    )
    disyuntor2_tab = fields.Char(
        string='Disyuntor dif.'
    )
    cargat_tab = fields.Char(
        string='Carga T (A)'
    )
    potencia_tab = fields.Char(
        string='Potencia actual'
    )
    estado_tab = fields.Char(
        string='Estado de equipo '
    )
    trabajo_tab = fields.Char(
        string='Trabajo realizado'
    )
    mante_tab = fields.Char(
        string='Mantenimiento'
    )
    garan_tab = fields.Char(
        string='Garantía'
    )
    ficha_tab = fields.Char(
        string='Ficha N°'
    )
    lacre_tab = fields.Char(
        string='Lacre/Sello'
    )

    equipo_tel = fields.Char(
        string='Tipo de equipo'
    )
    capacidad_tel = fields.Char(
        string='Capacidad'
    )
    tension_tel = fields.Char(
        string='Tensión'
    )
    contrasena_tel = fields.Char(
        string='Contraseña'
    )
    dns_tel= fields.Char(
        string='Servidor DNS fav.'
    )
    port_tel = fields.Char(
        string='Puerto HTTP'
    )
    brand_tel = fields.Char(
        string='Marca'
    )
    portact_tel = fields.Char(
        string='Puertos activos'
    )
    ip_tel = fields.Char(
        string='Dirección IPv4'
    )
    dnsalt_tel = fields.Char(
        string='Serv. DNS alt'
    )
    host_tel = fields.Char(
        string='Puerto Host'
    )
    model_tel = fields.Char(
        string='Modelo'
    )
    zonas_tel = fields.Char(
        string='Zonas act.'
    )
    mac_tel = fields.Char(
        string='Dir. Mac'
    )
    correo_tel = fields.Char(
        string='Correo'
    )
    ippub_tel = fields.Char(
        string='IP Pública'
    )
    serie_tel = fields.Char(
        string='N° Serie'
    )
    usuario_tel = fields.Char(
        string='Usuario'
    )
    iprouter_tel = fields.Char(
        string='Dir. IP router'
    )
    contrasena2_tel = fields.Char(
        string='Contraseña'
    )
    contrdeco_tel = fields.Char(
        string='Contraseña deco'
    )
    estado_tel = fields.Char(
        string='Estado de equipo '
    )
    trabajo_tel = fields.Char(
        string='Trabajo realizado'
    )
    mante_tel = fields.Char(
        string='Mantenimiento'
    )
    garan_tel = fields.Char(
        string='Garantía'
    )
    ficha_tel = fields.Char(
        string='Ficha N°'
    )
    lacre_tel = fields.Char(
        string='Lacre/Sello'
    )
    state = fields.Selection([
        ('draft', 'Pendiente'),
        ('in_progress', 'En progreso'),
        ('done', 'Realizado'),
        ('canceled', 'Cancelado')],
        string='Estado',
        default='draft'
    )


    @api.one
    def onchange_partner_id(self, partner_id):
        _log.info('-'*100)
        _log.info(partner_id)

    @api.one
    def button_in_progress(self):
        self.state = 'in_progress'

    @api.one
    def button_in_progress_back(self):
        self.state = 'draft'

    @api.one
    def button_done(self):
        product = self.line_ids
        # works = self.consumed_ids
        if not product:
            raise Warning('La configuración debe tener cámaras asociadas')
        else:
            self.state = 'done'

    @api.one
    def button_done_back(self):
        self.state = 'in_progress'

    @api.one
    def button_cancel(self):
        self.state = 'canceled'
